/*
 * Copyright 2009 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.lisp;

import net.morilib.util.Utils;

public abstract class NamableDatum extends Datum {
	
	//
	private String name;
	
	
	public NamableDatum(String name) {
		this.name = name;
	}
	
	
	public abstract String display();
	
	
	public String printName() {
		return (name == null) ? Utils.printHash(this) : name;
	}
	
	
	public String getName() {
		return name;
	}
	
	
	/*package*/ void setName(String name) {
		this.name = name;
	}
	
	
}
