/*
 * Copyright 2009 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.util;

import java.util.ArrayList;
import java.util.Collections;
import java.util.EmptyStackException;
import java.util.List;

/**
 * Implementation of stack with ArrayList.
 * <p>ArrayListˤ륹åμǤ.
 * 
 * @author MORIGUCHI, Yuichiro 2006/07/16
 */
public class ArrayListStack<E> implements Stack2<E> {
	
	//
	/*package*/ ArrayList<E> list = new ArrayList<E>();

	/**
	 * pushs the object.
	 * <p>֥Ȥץå夹.
	 * 
	 * @param o  the object to be pushed
	 * @return   the pushed object
	 */
	public E push(E o) {
		list.add(o);
		return o;
	}

	/**
	 * pops the object from this stack,
	 * the popped object is removed from this stack.
	 * <p>֥Ȥݥåפ.
	 * ݥåפ줿֥ȤϺ.
	 * 
	 * @return  the popped object
	 */
	public E pop() {
		if(list.size() <= 0) {
			throw new EmptyStackException();
		}
		return list.remove(list.size() - 1);
	}

	/**
	 * gets the object at the top of this stack,
	 * the object is not removed from this.
	 * <p>åƬˤ륪֥Ȥ.
	 * 
	 * @return  the top object of this stack
	 */
	public E peek() {
		if(list.size() <= 0) {
			throw new EmptyStackException();
		}
		return list.get(list.size() - 1);
	}

	/**
	 * gets the object which was pushed.
	 * <p>å줫nܤˤ륪֥Ȥ.
	 * 
	 * @return  the distance from the bottom of this stack
	 */
	public E get(int n) {
		/*if(list.size() <= n) {
			throw new IndexOutOfBoundsException();
		}
		return list.get(list.size() - n - 1);*/
		return list.get(n);
	}

	/**
	 * returns true if this stack is empty.
	 * <p>åΤȤtrue.
	 */
	public boolean isEmpty() {
		return (list.size() <= 0);
	}

	/**
	 * pops n objects from this stack and removes the objects
	 * from this stack.
	 * <p>ånĤΥ֥Ȥݥåפ.
	 * 
	 * @param n
	 */
	public void pop(int n) {
		if(list.size() < n) {
			throw new IndexOutOfBoundsException();
		}
		
		int size = list.size();
		for(int i = 1; i <= n; i++) {
			list.remove(size - i);
		}
	}

	/**
	 * returns the size of this stack.
	 * <p>֤.
	 * 
	 * @return  the size of this stack
	 */
	public int size() {
		return list.size();
	}

	/**
	 * clears all elements in this stack.
	 * <p>åˤǤ򥯥ꥢ.
	 */
	public void clear() {
		list.clear();
	}

	/**
	 * returns true if the given object is in this stack.
	 * <p>Ϳ줿֥ȤåˤȤtrue.
	 * 
	 * @param o  the object
	 * @return  true if the given object is in this stack
	 */
	public boolean contains(E o) {
		return list.contains(o);
	}
	
	
	public List<E> toList() {
		return Collections.unmodifiableList(list);
	}
	
	
	public boolean add(E o) {
		return list.add(o);
	}
	
	
	public void addAll(Stack2<E> s) {
		list.addAll(s.toList());
	}
	
	
	public String toString() {
		return list.toString();
	}
	
}
