/*
 * Copyright 2009 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.util;

import java.math.BigInteger;

/**
 * Inclimentor, or a Peano System.
 * 
 * @author MORIGUCHI, Yuichiro 2005/08/06
 */
public interface Inclimentor<A> {
	
	/**
	 * 
	 * @param i
	 * @return
	 */
	public boolean isZero();
	
	/**
	 * 
	 * @return
	 */
	public Inclimentor<A> suc();
	
	/**
	 * 
	 * @param step
	 * @return
	 */
	public Inclimentor<A> suc(int step);
	
	/**
	 * 
	 * @return
	 */
	public int toInt();
	
	/**
	 * 
	 * @param i
	 * @return
	 */
	public boolean equalInt(int i);
	
	/**
	 * 
	 * @param i
	 * @return
	 */
	public boolean equalInt(BigInteger i);
	
	/**
	 * 
	 * @param i
	 * @return
	 */
	public boolean equalIncliment(Inclimentor<?> i);
	
	
	public A getObject();
	
	
	public boolean hasNext();
	
	
	public Inclimentor<A> getZero();
	
}
