/*
 * Copyright 2009 Yuichiro Moriguchi
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */
package net.morilib.util;

import java.util.List;

/**
 * This interface represents the stack.
 * <p>åɽ󥿡եǤ.
 * 
 * @author MORIGUCHI, Yuichiro 2005/03/03
 */
public interface Stack2<E> {
	
	/**
	 * pushs the object.
	 * <p>֥Ȥץå夹.
	 * 
	 * @param o  the object to be pushed
	 * @return   the pushed object
	 */
	public E push(E o);
	
	/**
	 * pops the object from this stack,
	 * the popped object is removed from this stack.
	 * <p>֥Ȥݥåפ.
	 * ݥåפ줿֥ȤϺ.
	 * 
	 * @return  the popped object
	 */
	public E pop();
	
	/**
	 * gets the object at the top of this stack,
	 * the object is not removed from this.
	 * <p>åƬˤ륪֥Ȥ.
	 * 
	 * @return  the top object of this stack
	 */
	public E peek();
	
	/**
	 * gets the object which was pushed.
	 * <p>å줫nܤˤ륪֥Ȥ.
	 * 
	 * @return  the distance from the bottom of this stack
	 */
	public E get(int n);
	
	/**
	 * returns true if this stack is empty.
	 * <p>åΤȤtrue.
	 */
	public boolean isEmpty();
	
	/**
	 * pops n objects from this stack and removes the objects
	 * from this stack.
	 * <p>ånĤΥ֥Ȥݥåפ.
	 * 
	 * @param n
	 */
	public void pop(int n);
	
	/**
	 * returns the size of this stack.
	 * <p>֤.
	 * 
	 * @return  the size of this stack
	 */
	public int size();
	
	/**
	 * clears all elements in this stack.
	 * <p>åˤǤ򥯥ꥢ.
	 */
	public void clear();
	
	/**
	 * returns true if the given object is in this stack.
	 * <p>Ϳ줿֥ȤåˤȤtrue.
	 * 
	 * @param o  the object
	 * @return  true if the given object is in this stack
	 */
	public boolean contains(E o);
	
	
	public List<E> toList();
	
	
	public void addAll(Stack2<E> s);
	
	
	public boolean add(E o);

}
